﻿Imports System.Math
Public Class vgEEPROM
    Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Int32, ByVal lpFileName As String) As Int32
    Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Int32

    Dim tbCALName As String()
    Dim tbCALText As New ArrayList
    Dim tButRead As New ArrayList
    Dim tButSett As New ArrayList
    Dim mDPI As Double = 0
    Dim tMessage As String
    Dim PortState As Boolean = False

    Dim bUartRevState As Long = 0

    '定义读取配置文件函数
    Public Function GetINIFile(ByVal Section As String, ByVal AppName As String, ByVal lpDefault As String, ByVal FileName As String) As String
        Dim Str As String = LSet(Str, 256)
        GetPrivateProfileString(Section, AppName, lpDefault, Str, Len(Str), FileName)
        Return Microsoft.VisualBasic.Left(Str, InStr(Str, Chr(0)) - 1)
    End Function
    '定义写入配置文件函数
    Public Function WriteINIFile(ByVal Section As String, ByVal AppName As String, ByVal lpDefault As String, ByVal FileName As String) As Long
        WriteINIFile = WritePrivateProfileString(Section, AppName, lpDefault, FileName)
    End Function
    Private Sub vgEEPROM_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Uartbaud.Items.Add("1200")
        Uartbaud.Items.Add("9600")
        Uartbaud.Items.Add("19200")
        Uartbaud.Items.Add("115200")

        SmLength.Items.Add("4 点平滑")
        SmLength.Items.Add("8 点平滑")
        SmLength.Items.Add("16 点平滑")
        SmLength.Items.Add("32 点平滑")
        SmLength.Items.Add("64 点平滑")
        SmLength.SelectedIndex = 2

        Uartbaud.SelectedIndex = 2
        For Each sp As String In My.Computer.Ports.SerialPortNames
            Uartportname.Items.Add(sp)
        Next
        Uartportname.SelectedIndex = 0

        ReDim tbCALName(7)
        tbCALName(0) = "MasterReference"
        tbCALName(1) = "DACReference"
        tbCALName(2) = "DACBuffGain"
        tbCALName(3) = "MasterResistance"
        tbCALName(4) = "SlaveResistance"
        tbCALName(5) = "INLQuadratic"
        tbCALName(6) = "INLinear"
        tbCALName(7) = "INLConstant"

        tbCALText.Add(TextBox21)
        tbCALText.Add(TextBox22)
        tbCALText.Add(TextBox23)
        tbCALText.Add(TextBox24)
        tbCALText.Add(TextBox25)
        tbCALText.Add(TextBox26)
        tbCALText.Add(TextBox27)
        tbCALText.Add(TextBox28)

        tButRead.Add(Button1)
        tButRead.Add(Button2)
        tButRead.Add(Button3)
        tButRead.Add(Button4)
        tButRead.Add(Button5)
        tButRead.Add(Button6)
        tButRead.Add(Button7)
        tButRead.Add(Button8)

        tButSett.Add(Button9)
        tButSett.Add(Button10)
        tButSett.Add(Button11)
        tButSett.Add(Button12)
        tButSett.Add(Button13)
        tButSett.Add(Button14)
        tButSett.Add(Button15)
        tButSett.Add(Button16)


        mDPI = Me.CreateGraphics.DpiX / 96
        If mDPI > 1 Then
            Rxinfo.AppendText("系统缩放为：" & mDPI & vbCrLf)
        End If

    End Sub

    Private Sub bCmd_Connect_Click(sender As Object, e As EventArgs) Handles bCmd_Connect.Click
        If PortState = False Then
            SerialPort1.PortName = Uartportname.SelectedItem
            SerialPort1.BaudRate = Uartbaud.SelectedItem
            SerialPort1.Open()
            bCmd_Connect.Text = "Disconnect"
            PortState = True
            SerialPort1.DtrEnable = True
            ToolStripStatusLabel1.Text = "Port: " & SerialPort1.PortName
            ToolStripStatusLabel2.Text = "Baud: " & SerialPort1.BaudRate
            ToolStripStatusLabel3.Text = "Status: Connectting..."
        Else
            SerialPort1.Close()
            bCmd_Connect.Text = "Connect"
            PortState = False
            ToolStripStatusLabel1.Text = "Port: none"
            ToolStripStatusLabel2.Text = "Baud: none"
            ToolStripStatusLabel3.Text = "Status: Disconnected"
        End If
    End Sub

    Private Sub bCmd_CALtR_Click(sender As Object, e As EventArgs) Handles bCmd_CALtR.Click
        Dim bCALValue(8) As Long
        Dim tCmd As String = ""
        Dim iTimsk As Double = 0

        Dim dRMaster As Double = 0, dRSlave As Double = 0, dQuadratic As Double = 0, dLinear As Double = 0, dConstant As Double = 0

        dRMaster = CDbl(TextBox24.Text)
        TextBox24.Text = FormatNumber(dRMaster / 1000000, 6)
        dRSlave = CDbl(TextBox25.Text)
        TextBox25.Text = FormatNumber(dRSlave / 1000000, 6)
        dQuadratic = CDbl(TextBox26.Text)
        'TextBox26.Text = FormatNumber(dQuadratic / 100, 6)
        dLinear = CDbl(TextBox27.Text)
        'TextBox27.Text = FormatNumber(dLinear / 100, 6)
        dConstant = CDbl(TextBox28.Text)
        'TextBox28.Text = FormatNumber(dConstant / 100, 6)

        For i = 1 To 5
            bCALValue(i) = CLng(CDbl(tbCALText(i - 1).text) * 1000000)
        Next

        For i = 1 To 5
            tCmd = "STR" & Format(bCALValue(i), "00000000") & Trim(CStr(i)) & vbCrLf
            Rxinfo.AppendText(" <--- " & tCmd)
            Rxinfo.ScrollToCaret()
            SerialPort1.WriteLine(tCmd)
            iTimsk = Microsoft.VisualBasic.Timer
            Do
                Application.DoEvents()
            Loop Until Microsoft.VisualBasic.Timer > iTimsk + 0.5
        Next

        dRMaster = CDbl(TextBox24.Text)
        TextBox24.Text = CStr(dRMaster * 1000000)
        dRSlave = CDbl(TextBox25.Text)
        TextBox25.Text = CStr(dRSlave * 1000000)



    End Sub

    Private Sub bCmd_CALtE_Click(sender As Object, e As EventArgs) Handles bCmd_CALtE.Click
        Dim iTimsk As Double = 0
        For i = 0 To 7
            tButSett(i).Focus()
            tButSett_Click(tButSett(i), e)
            iTimsk = Microsoft.VisualBasic.Timer
            Do
                Application.DoEvents()
            Loop Until Microsoft.VisualBasic.Timer > iTimsk + 2
        Next
        bCmd_CALtE.Focus()

    End Sub

    Private Function ConvtoFloat(ByVal floatNumber As Double) As String()
        Dim tfLine As String = floatNumber.ToString("E6")
        Dim tfNumber As String = Mid(tfLine, 1, InStr(tfLine, "E") - 1)
        Dim tfExp As String = Mid(tfLine, InStr(tfLine, "E") + 1, tfLine.Length)
        Dim fNumber As Double = CDbl(tfNumber)
        Dim fExp As Integer = CInt(tfExp)

        Dim iNumber As Long = 0, iNumH As Long = 0, iNumL As Long = 0

        'If fNumber >= 0 Then
        'iNumber = fNumber * 1000000 '+ 8388608
        'Else
        'iNumber = 8388608 + fNumber * 100000
        'End If
        iNumber = Abs(fNumber) * 1000000

        iNumH = iNumber \ 256
        iNumL = iNumber - iNumH * 256
        iNumL = iNumL * 256

        fExp = fExp - 6
        'MsgBox(iNumber.ToString)
        'MsgBox(fExp.ToString)
        If fNumber >= 0 Then
            iNumL = iNumL + 128
        End If
        If fExp >= 0 Then
            iNumL = iNumL + fExp + 64
        Else
            iNumL = iNumL + Abs(fExp)
        End If

        Return Split(iNumH.ToString("D5") & "," & iNumL.ToString("D5"), ",")
    End Function

    Private Function Getfolat(ByVal iMSB As Long, ByVal iLSB As Long) As Double
        Dim dResult As Double = 0
        Dim iL As Byte = 0
        Dim mSGN, eSGN, eExp As Byte

        iL = iLSB >> 8
        dResult = iMSB * 256 + iL

        iLSB = iLSB << 8
        iLSB = iLSB >> 8
        mSGN = iLSB And 128
        If mSGN = 0 Then
            dResult = 0 - dResult
        End If

        eSGN = iLSB And 64
        eExp = iLSB And 63
        'MsgBox("Result=" & dResult & ",SGN=" & eSGN & ",Exp=" & eExp)
        If eExp > 0 Then
            If eSGN = 0 Then
                dResult = dResult / 10 ^ eExp
            Else
                dResult = dResult * 10 ^ eExp
            End If
        End If
        Return dResult
    End Function

    Private Sub bCmd_Debug_Click(sender As Object, e As EventArgs) Handles bCmd_Debug.Click
        Dim tCmd As String = ""
        tCmd = tbDebug.Text & vbCrLf
        Rxinfo.AppendText(" <--- " & tCmd)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tCmd)
    End Sub

    Private Sub bCmd_CalHelper_Click(sender As Object, e As EventArgs) Handles bCmd_CalHelper.Click
        Dim bCALValue As Double = CDbl(tbCALmeter.Text) * 0.7
        Dim tCmd As String = ""
        Dim tCline() As String
        Dim iTimsk As Double = 0
        'bCALValue = CLng(CDbl(tbCALmeter.Text) * 7000000)
        'tCmd = "CAL" & Format(bCALValue, "00000000") & "0" & vbCrLf

        tCline = ConvtoFloat(bCALValue)
        tCmd = "STE000" & tCline(0) & "0" & vbCrLf
        Rxinfo.AppendText(" <--- " & tCmd)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tCmd)

        iTimsk = Microsoft.VisualBasic.Timer
        Do
            Application.DoEvents()
        Loop Until Microsoft.VisualBasic.Timer > iTimsk + 1

        tCmd = "STE002" & tCline(1) & "0" & vbCrLf
        Rxinfo.AppendText(" <--- " & tCmd)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tCmd)
    End Sub

    Private Sub bCmd_RST_Click(sender As Object, e As EventArgs) Handles bCmd_RST.Click
        Dim tCmd As String = ""
        tCmd = "RST200000000" & vbCrLf
        Rxinfo.AppendText(" <--- " & tCmd)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tCmd)
    End Sub

    Private Sub SerialPort1_DataReceived(sender As Object, e As IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        tMessage = Trim(SerialPort1.ReadLine())
        If bUartRevState = 0 Then
            Me.Invoke(New EventHandler(AddressOf ReceiveUartMsg))
        Else
            Select Case bUartRevState
                Case 1 : Me.Invoke(New EventHandler(AddressOf ReceiveGlobalSetting))

            End Select
            bUartRevState = 0
        End If


    End Sub

    Private Sub ReceiveUartMsg(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Rxinfo.AppendText(tMessage & vbCrLf)
        Rxinfo.ScrollToCaret()

    End Sub

    Private Sub ReceiveGlobalSetting(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim tLine() As String
        Dim iAddress As Long = 0
        Dim iMSB As Long = 0
        Dim iLSB As Long = 0
        Dim icMSB As Long = 0
        Dim icLSB As Long = 0
        Dim dResult As Double = 0
        'Dim iArrayAddress As Long = 0
        Rxinfo.AppendText(tMessage & vbCrLf)

        Try
            tLine = Split(tMessage, " ")
            iAddress = Convert.ToInt32(tLine(1), 16)
            iMSB = CLng(tLine(3))
            iLSB = CLng(tLine(5))
            icMSB = CLng(tLine(7))
            icLSB = CLng(tLine(9))
        Catch ex As Exception
            'MsgBox("Receive Data Format Error!")
            Rxinfo.AppendText("Receive Data Format Error! Please Check and ReTry." & vbCrLf)
            'Rxinfo.ScrollToCaret()
        End Try

        If (icMSB <> iMSB) Or (icLSB <> iLSB) Then
            Rxinfo.AppendText("Receive Data Check Error! Please Check and ReTry." & vbCrLf)
        Else
            'MsgBox(Getfolat(iMSB, iLSB))
            dResult = Getfolat(iMSB, iLSB)
            iAddress = iAddress / 4
            tbCALText(iAddress).text = dResult
        End If

        'Rxinfo.AppendText(tMessage & vbCrLf)
        Rxinfo.ScrollToCaret()
    End Sub

    Private Sub bCmd_LimitLTF_Click(sender As Object, e As EventArgs)

    End Sub

    Private Sub bCmd_SetRAM_Click(sender As Object, e As EventArgs) Handles bCmd_SetRAM.Click
        Dim tSettcmd As String = "STSabb00dd0x", ttHreshold As String = "", tVoltgteSettingValue As String = ""
        Dim lVoltageSettingValue As Long = 0, iTimsk As Double = 0

        If Loopclose.Checked Then
            tSettcmd = Replace(tSettcmd, "a", "1")
        Else
            tSettcmd = Replace(tSettcmd, "a", "0")
        End If

        Select Case SmLength.SelectedIndex
            Case 0 : tSettcmd = Replace(tSettcmd, "bb", "04")
            Case 1 : tSettcmd = Replace(tSettcmd, "bb", "08")
            Case 2 : tSettcmd = Replace(tSettcmd, "bb", "16")
            Case 3 : tSettcmd = Replace(tSettcmd, "bb", "32")
            Case 4 : tSettcmd = Replace(tSettcmd, "bb", "64")
        End Select
        ttHreshold = tHreshold.Text
        If Math.Abs(CInt(ttHreshold)) < 10 Then ttHreshold = "0" & Trim(CStr(Math.Abs(CInt(ttHreshold)))) Else ttHreshold = Trim(CStr(Math.Abs(CInt(ttHreshold))))
        tSettcmd = Replace(tSettcmd, "dd", ttHreshold) & vbCrLf
        'MsgBox(tSettcmd)
        Rxinfo.AppendText(" <--- " & tSettcmd)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tSettcmd)

        iTimsk = Microsoft.VisualBasic.Timer
        Do
            Application.DoEvents()
        Loop Until Microsoft.VisualBasic.Timer > iTimsk + 0.5

        lVoltageSettingValue = CDbl(nStvBox.Text) * 1000000
        tVoltgteSettingValue = Format(lVoltageSettingValue, "00000000")
        tVoltgteSettingValue = "STV" & tVoltgteSettingValue & "0" & vbCrLf
        Rxinfo.AppendText(" <--- " & tVoltgteSettingValue)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tVoltgteSettingValue)
    End Sub

    Private Sub tButRead_Click(sender As System.Object, e As EventArgs) Handles Button1.Click, Button2.Click, Button3.Click, Button4.Click, Button5.Click, Button6.Click, Button7.Click, Button8.Click
        'MsgBox(sender.name)
        Dim iArray As Long = CLng(Mid(sender.name, 7)) - 1
        Dim dValue As Double = CDbl(tbCALText(iArray).Text)
        Dim tCmd As String = ""
        'Dim tCline() As String
        'MsgBox(dValue)

        bUartRevState = 1
        tCmd = "RTE" & Format(iArray * 4, "000") & "000000" & vbCrLf
        Rxinfo.AppendText(" <--- " & tCmd)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tCmd)
    End Sub

    Private Sub tButSett_Click(sender As System.Object, e As EventArgs) Handles Button9.Click, Button10.Click, Button11.Click, Button12.Click, Button13.Click, Button14.Click, Button15.Click, Button16.Click
        'MsgBox(sender.name)
        Dim iArray As Long = CLng(Mid(sender.name, 7)) - 9
        Dim dValue As Double = CDbl(tbCALText(iArray).Text)
        'MsgBox(iArray)
        Dim tCmd As String = ""
        Dim tCline() As String
        Dim iTimsk As Double = 0

        tCline = ConvtoFloat(dValue)
        tCmd = "STE" & Format(iArray * 4, "000") & tCline(0) & "0" & vbCrLf
        Rxinfo.AppendText(" <--- " & tCmd)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tCmd)

        iTimsk = Microsoft.VisualBasic.Timer
        Do
            Application.DoEvents()
        Loop Until Microsoft.VisualBasic.Timer > iTimsk + 1

        'tCmd = "RTE" & Format(iArray * 4, "000") & "000000" & vbCrLf
        'Rxinfo.AppendText(" <--- " & tCmd)
        'Rxinfo.ScrollToCaret()
        'SerialPort1.WriteLine(tCmd)

        'iTimsk = Microsoft.VisualBasic.Timer
        'Do
        'Application.DoEvents()
        'Loop Until Microsoft.VisualBasic.Timer > iTimsk + 0.2

        tCmd = "STE" & Format(iArray * 4 + 2, "000") & tCline(1) & "0" & vbCrLf
        Rxinfo.AppendText(" <--- " & tCmd)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tCmd)

        iTimsk = Microsoft.VisualBasic.Timer
        Do
            Application.DoEvents()
        Loop Until Microsoft.VisualBasic.Timer > iTimsk + 1

        tCmd = "RTE" & Format(iArray * 4, "000") & "000000" & vbCrLf
        Rxinfo.AppendText(" <--- " & tCmd)
        Rxinfo.ScrollToCaret()
        SerialPort1.WriteLine(tCmd)
    End Sub

    Private Sub bCmd_CALfE_Click(sender As Object, e As EventArgs) Handles bCmd_CALfE.Click
        Dim iTimsk As Double = 0
        'Me.Invoke(New EventHandler(AddressOf ReceiveGlobalSetting))
        'tButRead_Click(tButRead(0), e)
        For i = 0 To 7
            tButRead(i).Focus()
            tButRead_Click(tButRead(i), e)
            iTimsk = Microsoft.VisualBasic.Timer
            Do
                Application.DoEvents()
            Loop Until Microsoft.VisualBasic.Timer > iTimsk + 1
        Next
        bCmd_CALfE.Focus()
    End Sub

    Private Sub bCmd_CALtF_Click(sender As Object, e As EventArgs) Handles bCmd_CALtF.Click
        SaveFileDialog1.DefaultExt = "log"
        SaveFileDialog1.Filter = "Text files (*.log)|*.log|All files (*.*)|*.*"
        If SaveFileDialog1.ShowDialog() = DialogResult.OK Then

            For i = 0 To 7
                WriteINIFile("GlobalSetting", tbCALName(i), tbCALText(i).text, SaveFileDialog1.FileName)
            Next

            MsgBox("当前设置值已保存在：" & vbCrLf & SaveFileDialog1.FileName & vbCrLf & "请妥善保管和管理此文件。")
        End If
    End Sub

    Private Sub bCmd_CALfF_Click(sender As Object, e As EventArgs) Handles bCmd_CALfF.Click
        OpenFileDialog1.FileName = ""
        OpenFileDialog1.DefaultExt = "log"
        OpenFileDialog1.Filter = "Text files (*.log)|*.log|All files (*.*)|*.*"
        If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
            For i = 0 To 7
                tbCALText(i).text = GetINIFile("GlobalSetting", tbCALName(i), "", OpenFileDialog1.FileName)
            Next
            MsgBox("已载入记录文件：" & vbCrLf & OpenFileDialog1.FileName & vbCrLf & "中的设置，请核对连接的机器是否是该份文件的宿主。")
        End If
    End Sub
End Class
